/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef     _FS_EXT2_QUOTA_INSTANCE_H_
#define     _FS_EXT2_QUOTA_INSTANCE_H_

#include "nest_quota_instance.h"

class FsExt2QuotaInstance : public QuotaInstance {

    private:

    public:
        NestReplyStatus add_entity(const char *name,
                                   int is_user,
                                   const char *dev,
                                   double size,
                                   int inode_count);

        NestReplyStatus delete_entity(const char *name,
                                      int is_user,
                                      const char *dev);

        NestReplyStatus update_entity(const char *name,
                                      int is_user,
                                      const char *dev,
                                      double new_size,
                                      int new_inode_count);

        NestReplyStatus view_entity_usage(const char *name,
                                          int is_user,
                                          const char *dev,
                                          double *size,
                                          int *inode_count);

        NestReplyStatus initialize(const char *dev);
};

#endif
