/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef _NEST_ARCH_SPECIFIC_H
#define _NEST_ARCH_SPECIFIC_H

#include <stdio.h>

#ifdef HAS_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifndef HAS_SOCKLEN_T
#define SOCKLEN_T int
#endif
/*
#ifdef HAS_SYS_QUOTA_H
#include <sys/quota.h>
#endif
*/
#ifdef HAS_LINUX_QUOTA_H
#include <linux/types.h>
#include <linux/quota.h>
#endif

#ifdef HAS_SYS_FS_UFS_QUOTA_H
#include <sys/fs/ufs_quota.h>
#endif

#ifdef HAS_FSTAB_H
#include <fstab.h>
#endif

#ifdef HAS_SYS_VFSTAB_H
#include <sys/vfstab.h>
#endif

#ifdef HAS_SYS_STAT_H
#include <sys/stat.h>
#endif

#ifdef HAS_SYS_STATVFS_H
    #include <sys/statvfs.h>
    typedef struct statvfs nest_fsstat;
#elif defined(HAS_SYS_STATFS_H)
    #include <sys/statfs.h>
    typedef struct statfs nest_fsstat;
#else
    #error Gotta have statfs or statvfs!
#endif

typedef struct stat nest_stat;

#endif
