/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef _NEST_CONCURRENCY_MODEL_H
#define _NEST_CONCURRENCY_MODEL_H

#include "nest_client.h"

typedef void ( *taskDoneCallback ) ( nestClient *, NestReplyStatus, int model );

class nestConcurrencyModel {

public:
    
    nestConcurrencyModel( int id );
    
    virtual ~nestConcurrencyModel( ) { }
    
    virtual NestReplyStatus addTask( nestClient *client ) = 0;
    
    virtual NestReplyStatus makeProgress( fd_set *r_ready, fd_set *w_ready ) =0;

    virtual int getMaxfd( ) = 0;

    virtual int getId();
    
    virtual NestReplyStatus abortTask( nestClient *client );

    virtual NestReplyStatus pauseTask( nestClient *client );

    virtual NestReplyStatus updateTaskInfo( nestClient *client );

    virtual NestReplyStatus sigChild( int, siginfo_t *, void *, fd_set *ready );

    virtual NestReplyStatus debugLevel( int new_level );

    virtual char* toString( ) = 0;
    
protected:
    int maxfd;
    int id;
    int concurrency_size;
};

#include "nest_common.h"

#endif
