/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef     __NEST_LOT_H__
#define     __NEST_LOT_H__

#include "nest_storage_common.h"

#define G_LOT 0
#define BE_LOT 1

struct
NestLot {
    char                    lot_handle[NEST_NAMELEN];
    char                    parent_lot_handle[NEST_NAMELEN];
    char                    owner[NEST_NAMELEN];
    char                    lot_users[NEST_MESSAGESIZE];
    unsigned int            is_user;
    char                    dev[NEST_NAMELEN];
    double                  total_size;
    double                  size;
    double                  used;
    double                  start_time;
    double                  duration;
    double                  time_left;
    int                     cost;
    int                     lot_type;
};

typedef struct NestLot NestLot;

struct
NestLotList {
    NestLot                stat;
    struct NestLotList    *next;
};

typedef struct NestLotList NestLotList;

#endif
