#include "nest_protocol_advertise.h"

nestProtocolAdvertise::nestProtocolAdvertise( ) {
    this->socket = -1;
    memset( &address, 0, sizeof( address ) );
}

nestProtocolAdvertise::~nestProtocolAdvertise( ) {
}

bool
nestProtocolAdvertise::sendTransferInfo( class nestRequest *req ) {
    return true;
}

bool
nestProtocolAdvertise::connect( const char *host, int port ) {

    hostent *hostp = NestGethostbyname( host );
    if ( hostp == NULL ) return false;

    socket = NestSocket( AF_INET, SOCK_DGRAM, 0 );
    if ( socket > 0 ) {
        address.sin_family = AF_INET;
        address.sin_port   = htons( (unsigned short) port );
        memcpy( &address.sin_addr, hostp->h_addr, hostp->h_length );
    }
    NestFree( hostp );

    return (socket > 0);
}

nestProtocol *
nestProtocolAdvertise::clone( ) {
    nestProtocolAdvertise *clone = new nestProtocolAdvertise();
    clone->socket = this->socket;
    memcpy( (void*)&clone->address, (void*)&this->address, sizeof( address ) );
    return clone;
}
    
NestReplyStatus 
nestProtocolAdvertise::receive_state( int pipe ) {
        // does the work of connect, for POP workers
    socket = NestSocket( AF_INET, SOCK_DGRAM, 0 );
    if ( socket < 0 ) return NEST_UNKNOWN_ERROR;

    ssize_t s = NestReadn( pipe, (void*)&address, sizeof( address ) );
    return ( s == sizeof( address ) ) ? NEST_SUCCESS : NEST_NO_CONNECTION;
}

NestReplyStatus 
nestProtocolAdvertise::send_state( int pipe ) {
    ssize_t s = NestWriten( pipe, (void*)&address, sizeof( address ) );
    return ( s == sizeof( address ) ) ? NEST_SUCCESS : NEST_NO_CONNECTION;
}


ssize_t
nestProtocolAdvertise::Send( const char *buffer, ssize_t n ) {
    int s = sendto( socket, (void *)buffer, n, 0, 
            (const struct sockaddr *)&address, sizeof( address ) );
    if ( s < 0 ) {
        nest_perror( "nestProtocolAdvertise sendto" );
    }
    nest_debug( NEST_DEBUG_PROTOCOL, "Sent %.20s . . . to collector: %u.\n", 
            buffer, s );
    return s;
}

ssize_t
nestProtocolAdvertise::Receive( char *buffer, ssize_t n ) {
    return -1;
}

bool
nestProtocolAdvertise::sendAck() {
    return true;
}

bool
nestProtocolAdvertise::sendFilesize( long int filesize ) {
    return false;
}

nestRequest *
nestProtocolAdvertise::receiveRequest( fd_set *readies ) {
    return NULL;
}

bool
nestProtocolAdvertise::sendErrorMessage( const char* filename, const char* func_name,  int error ) {
    return false;
}
