/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent,
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * For contact information, please visit:
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef _NEST_PROTOCOL_ADVERTISE_H
#define _NEST_PROTOCOL_ADVERTISE_H

#include "nest_common.h"
#include "nest_protocol.h"

class nestProtocolAdvertise : public nestProtocol {
public:


    nestProtocolAdvertise( );

    virtual ~nestProtocolAdvertise();

    virtual ssize_t Receive( char *buffer, ssize_t n );

    virtual ssize_t Send( const char *buffer, ssize_t n );

    virtual int getType( ) { return ADVERTISE_PROTOCOL; }

    virtual bool hasSocket() { return true; }

    virtual bool sendErrorMessage(  const char* filename, const char* func_name, int error );
    
    virtual int getSocket() { return socket; }

    virtual NestReplyStatus receive_state( int pipe );

    virtual NestReplyStatus send_state( int pipe );

    virtual bool sendAck();

    virtual bool sendFilesize( long int filesize );

    virtual nestRequest *receiveRequest( fd_set *readies );

    bool connect( const char *host, int port );
    
    virtual bool sendTransferInfo( class nestRequest *req );

    virtual nestProtocol *clone();

private:
    void init( );
    
    int     socket;
    struct  sockaddr_in address;
};

#endif
