/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent,
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * For contact information, please visit:
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef _NEST_PROTOCOL_STORAGE_H
#define _NEST_PROTOCOL_STORAGE_H

#include "nest_common.h"
#include "nest_protocol.h"
//#include "nest_client.h"

class nestProtocolStorage: public nestProtocol {

public:

    virtual bool sendErrorMessage( const char* filename, const char* func_name, int error );

    virtual bool sendAck( );

    virtual nestRequest* receiveRequest( fd_set *ready );

    virtual bool sendFilesize( long size );


    virtual int  set_filenames(char *logical_name, char *physical_name);

    virtual int  get_filenames(char *logical_name, char *physical_name);


    virtual int  set_open_flags(int flags);

    virtual int  get_open_flags(int *flags);


    virtual int  set_open_filesize(off_t size);

    virtual int  get_open_filesize(off_t *size);


    virtual int  set_ids(user_id_t uid, user_id_t gid);

    virtual int  get_ids(user_id_t *uid, user_id_t *gid);

    virtual char * get_fdkey();

    virtual int set_fdkey( char *fdkey );

    virtual void set_fd_cache_status( bool status );

    virtual bool get_fd_cache_status( );

};
#endif
